#! /usr/bin/perl -w

#20x ""  == concept count
@best_classifiers=("","","","","","","","","","","","","","","","","","","","",);

#properties
$feature_name = read_feature_name();

sub read_feature_name
{

    open FF, "_FeatureName";
    @content = <FF>;
    close FF;
    return $content[0];
}

#$concept = $ARGV[0];
@files=();
$path1 = "./results/";
opendir(MODS, $path1) || die("Cannot open directory $path1");
@files1 = readdir(MODS);
closedir(MODS);

$path2 = "./results.2/";
opendir(MODS, $path2) || die("Cannot open directory $path2");
@files2 = readdir(MODS);
closedir(MODS);

foreach $i (@files1)
{
    push(@files,"./results/$i");
}

foreach $i (@files2)
{
    push(@files,"./results.2/$i");
}

print "==============================\n";
print " created classifiers stats\n";
print "==============================\n";
print " stage | concept | info\n";
print "==============================\n";
foreach $bestfile (@files)
{
    if($bestfile =~ /.*\.best$/)
    {
        #print "opening & parsing file $bestfile....\n";
	open( FI, $bestfile) || die ("could not open $bestfile file");
	my @content = ();
	@content = <FI>;
	close FI;
	
	$concept="";
	if($bestfile =~ /.*\/([0-9]*)\.best$/)
	{
	    $concept=$1;
	}
	if($concept eq "")
	{
	    print "ERROR parsing concept number\n";
	}
	
	$stage=0;
	if($bestfile =~ /.*results.*/)
	{
	    $stage=1;
	}
	if($bestfile =~ /.*results\.2.*/)
	{
	    $stage=2;
	}
	
	$max = 0.0;
	$parsed_classif=0;
	$cnt = 0;
	$max_index=-1;
	
	foreach $cl (@content)
	{
	    if($cl =~ /^([0-9\.]*)\ ([0-9\.]*)\ ([0-9]*)\ -1\ p\ ([0-9\.]*).*$/)
	    {
		if($4 > $max)	
		{
		    $max=$4;
		    $max_index=$cnt;
		    #print "found next maxima.... $cnt\n";
		}
		$parsed_classif++;
	    }
	    $cnt++;
	}
	if($cnt != $parsed_classif)
	{
	    print "Error: $bestfile, input format wrong";
	}
	if($max_index != -1)
	{
	    $line =$content[$max_index]; 
    	    #print "$bestfile - $line";	
    	    #checkout best_classifier array if there's better one
    	    if($best_classifiers[$concept] eq "")
    	    {
    		$best_classifiers[$concept]="$stage $concept $line";	
    		print "$stage $concept $line";
    	    }else
    	    {
    		$def = $best_classifiers[$concept];
    		$quality_stored=999.0;
    		if( $def =~ /.*p\ ([0-9\.]*)\ *$/ )
    		{
    		    $quality_stored=$1;
    		}
    		$quality_current=999.0;
    		if( $line =~ /.*p\ ([0-9\.]*)$/ )
    		{
    		    $quality_current=$1;    
    		}
    		if($quality_stored != 999.0 && $quality_current != 999.0)
    		{
    		    if($quality_stored<$quality_current)
    		    {
    			$best_classifiers[$concept]="$stage $concept $line";
    			print "$stage $concept $line";
    		    }else
    		    {
    			print "$stage $concept ->old classifier is better ($quality_stored, $quality_current)\n";
    		    }
    		}else
    		{
    		    print "$stage $concept Error\n";
    		}
    	    }
    	    
    	}else
    	{
    	    printf "$stage $concept -> nothing\n";
    	}
    }
}

print "\ncopying model files to output folder....\n\n";

foreach $i (@best_classifiers)
{
    if($i =~ /^([0-9]*)\ ([0-9]*)\ ([0-9\.]*)\ ([0-9\.]*)\ ([0-9]*)\ [0-9\-]*\ p.*/)
    {
	$stage = 1;
	$stage = $1;
	$concept= $2;
	$g = $3;
	$c = $4;
	$w = $5;
	$inputfile = "./mod/$concept/$concept-${feature_name}.tr_${g}_${c}_${w}.mod";
	if($stage == 2)
	{
	    $inputfile = "./mod.2/$concept/$concept-${feature_name}.tr_${g}_${c}_${w}.mod";
	}
	system("cp \"$inputfile\" ./output");
    }

}
print "Done.\n\n";




