#! /usr/bin/perl -w

#properties
$feature_name = read_feature_name();

sub read_feature_name
{

    open FF, "_FeatureName";
    @content = <FF>;
    close FF;
    return $content[0];
}



################################################################
################################################################
#fill out predict task array
$svm_predict_image="./libsvm-/svm-predict";
my @predict_tasks=();

foreach $concept ("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", )
{

    opendir(MODS, "./mod.2/$concept/") || die("Cannot open directory ./mod.2/$concept");
    @files = readdir(MODS);
    closedir(MODS);
    
    foreach $mod_file (@files)
    {
        if($mod_file =~ /^([0-9]*)\-.*mod$/)
	{
	    $input_te_fname="$1-${feature_name}.te.p";
	    $output_predict_file="./predict.2/$concept/${mod_file}.predict.p";
	    $output_sout_file="./predict.2/logs/$concept/${mod_file}.p.sout";
	    $full_mod_file="./mod.2/$concept/$mod_file";
	    #print FWT "  push(\@tasks,\"$svm_predict_image \\\"./input/${input_te_fname}\\\" \\\"${full_mod_file}\\\" \\\"${output_predict_file}\\\"	>${output_sout_file}\"); \n";
	    push(@predict_tasks,"$svm_predict_image \\\"./input/${input_te_fname}\\\" \\\"${full_mod_file}\\\" \\\"${output_predict_file}\\\"	>${output_sout_file}; ");
	    
	    $input_te_fname="$1-${feature_name}.te.n";
	    $output_predict_file="./predict.2/$concept/${mod_file}.predict.n";
	    $output_sout_file="./predict.2/$concept/${mod_file}.n.sout";
	    $full_mod_file="./mod.2/$concept/$mod_file";
	    #print FWT "  push(\@tasks,\"$svm_predict_image \\\"./input/${input_te_fname}\\\" \\\"${full_mod_file}\\\" \\\"${output_predict_file}\\\"	>${output_sout_file}\"); \n";
	    push(@predict_tasks,"$svm_predict_image \\\"./input/${input_te_fname}\\\" \\\"${full_mod_file}\\\" \\\"${output_predict_file}\\\"	>${output_sout_file}; ");
	    
	}
    }
}
    print "==================\nprinting out no. final sge predict_tasks: ";
    $num = @predict_tasks;
    print "$num\n";


################################################################
################################################################
#now create sge runner for predict task
$task_fname = "sge_predict2.pl";
$curr_path = $ENV{PWD};

open FWT, ">$task_fname";
#write head
print FWT "#!/usr/bin/perl -w\nuse lib \"$curr_path\";\nuse MultiTask;\
\@tasks = ();\
\
# sge setup\
my \$dir = \"$curr_path\";\
my \$name = \"TV_pred2\";\
mtSetSgeDir(\$dir);\
mtSetSgeName(\$name);\
mtSetSgeScriptName(\$0);\
\$mem = \"400M\";\
\
mtSetSgeArgs(\"-l ram_free=\$mem\");\
\
# set up environment for mono\
\$ENV{LD_LIBRARY_PATH}=\"/usr/local/share/Mono-2.4/lib\";\
\$ENV{PATH}=\$ENV{PATH} . \":/usr/local/share/Mono/bin\";\
\
chdir \$dir;\
";

#write tasks
print FWT "#TASKS\n";

$num_jobs_in_task=20;
for($i=0;$i<@predict_tasks;$i=$i+$num_jobs_in_task)
{
    $task_line="";
    for($y=$i;$y<$i+$num_jobs_in_task;$y++)
    {
	if($y >= @predict_tasks)
	{
	    next;
	}
	$task_line .= $predict_tasks[$y];
    }
    print FWT "  push(\@tasks, \"ulimit -t 10800; sleep 10; ${task_line}\");\n";
}

#write tail
print FWT "\n#run all\n\nMultiTaskGo(\$ARGV[0], \@tasks);\n";

close FWT;
system ("chmod 774 $task_fname");











