#! /usr/bin/perl -w
use lib "/mnt/matylda1/trecvid/2010/hlf/tests/test1";
use MultiTask;

@tasks = ();

############################################################
######### ###################################################
# sge setup

my $dir = "/mnt/matylda1/trecvid/2010/hlf/tests/test1";
my $name = "TV_predict";

########################################
mtSetSgeDir($dir);
mtSetSgeName($name);
mtSetSgeScriptName($0);
$mem = "400M";
#mtSetSgeArgs("-l ram_free=$mem -l mem_free=$mem -l long_job_03=1");

#
# !!!!!!!!!!!!!!!!!!!!!!!
# pouziva prostreden minerva2
#


mtSetSgeArgs("-l ram_free=$mem -l matylda1=1");

############################################################
############################################################
# set up environment for mono
$ENV{LD_LIBRARY_PATH}="/usr/local/share/Mono-2.4/lib";
$ENV{PATH}=$ENV{PATH} . ":/usr/local/share/Mono/bin";

chdir $dir;

############################################################
############################################################
# vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv #
#  fill @tasks BELOW
# vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv #
############################################################
############################################################

    opendir(TEDATA,"./input/");
    @tefiles = readdir(TEDATA);
    closedir(TEDATA);

    @helparray=("");
    foreach $concept ("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20",)
    {

	opendir(MODS, "./mod/$concept/") || die("Cannot open directory ./mod/$concept");
	@files = readdir(MODS); 
	closedir(MODS);
	
	foreach $model (@files)
	{
	    foreach $tefile (@tefiles)
	    {
		if($model =~ /^.*mod$/) # filter out unwanted folder contents just like ., .., etc.
		{
		    if($tefile =~ /^$concept\-.*\.te\.([NnPp])$/)#filter tefiles because array contains all files, we need filter only ".te.{n,p}" files of desired concept   
		    {
			$type=$1;
			push(@helparray,"./libsvm-/svm-predict \"./input/$tefile\" \"./mod/$concept/$model\" \"./predict/$concept/$model.predict.$type\" >./predict/logs/$concept/$model.$type.sout ; ");
		    }
		}	
	    }
	}
    }

$num_jobs_in_task=30;
for($i=0;$i<@helparray;$i=$i+$num_jobs_in_task)
{
    $task_line="";
    for($y=$i;$y<$i+$num_jobs_in_task;$y++)
    {
        if($y >= @helparray)
        {
            next;
        }
        $task_line .= $helparray[$y];
    }
    push(@tasks,"ulimit -t 10800; ${task_line} sleep 60;");
}
                                                                


############################################################
############################################################
# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ #
#  fill @tasks ABOVE
# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ #
############################################################
############################################################

MultiTaskGo($ARGV[0], @tasks);
