#! /usr/bin/perl -w
use lib "/mnt/matylda1/trecvid/2010/hlf/tests/test1";
use MultiTask;

@tasks = ();

############################################################
# sge setup

my $dir = "/mnt/matylda1/trecvid/2010/hlf/tests/test1";
my $name = "TV_train";

########################################
mtSetSgeDir($dir);
mtSetSgeName($name);
mtSetSgeScriptName($0);
$mem = "400M";
#mtSetSgeArgs("-l ram_free=$mem -l mem_free=$mem -l long_job_03=1");

#
# !!!!!!!!!!!!!!!!!!!!!!!
# pouziva prostreden minerva2
#


mtSetSgeArgs("-l ram_free=$mem");

############################################################
# set up environment for mono
$ENV{LD_LIBRARY_PATH}="/usr/local/share/Mono-2.4/lib";
$ENV{PATH}=$ENV{PATH} . ":/usr/local/share/Mono/bin";

chdir $dir;

############################################################
############################################################
# vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv #
#  fill @tasks BELOW
# vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv #
############################################################
############################################################

    #Procedure:
    #read input train files
    #create all jobs with this g && c params grid:
    @order2=(-10,-8,-6,-4,-2,0,2,4,6,8,10);
    # and with w parameter in range (.55, .8, 1.0)
    #compute all on sge
    #compute all predict on sge
    #run ./makeresults1 to create first run statistics
    # it tells us best classifier for each concept or no classifier
    # if no classifier => shrink negative data size for each concept by 1/2 & rerun in sge again (file _runtrainshr.pl)
    # otherwise search again closest neighbour of this classifier => 8x3 classifier
    #  new file _runtrain2.pl will be created & again executed in sge
    # for results _runtrainshr.pl && _runtrain2.pl do predict in sge
    # select best classifier for all concept (selecting the best classifier in last sge run)
    # now we've best classifiers, if _runtrainshr.pl creates no valid model content we have no model for this concept

    opendir(IMD, "./input/") || die("Cannot open directory input");
    @files = readdir(IMD); 
    closedir(IMD);
    
    #@order1=(-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10);
    @order2=(-10,-8,-6,-4,-2,0,2,4,6,8,10);

    foreach $concept (@files){
	foreach $c (@order2){
	    foreach $g (@order2) {
		foreach $w (0.55,0.8,1){
		    
		    if($concept =~ /^.*\.tr$/)#filter only wanted input files!
		    {
			$truec=2 ** $c;
			$trueg = 2 ** $g;
			
			$helpw = 100*$w;
			$negw = 1.0-$w;
			$posw = $w;
			
			$outfile_identif = "${concept}_${trueg}_${truec}_${helpw}";
			
			#parse classidentifier
			$class_id="1";
			if($concept =~ /^([0-9]*)\-.*/)
			{
			    $class_id = $1;
			}
			push(@tasks,"ulimit -t 10800; ./libsvm-/svm-train -g $trueg -c $truec -w0 $negw -w${class_id} $posw -m 300 -b 1 \"./input/$concept\" \"./mod/$class_id/${outfile_identif}.mod\" >./logs/$class_id/${outfile_identif}.sout 2>./logs/$class_id/${outfile_identif}.serr; sleep 60;");
			#push(@tasks,$concept);
		    }
		
		}
	    }
	}
    }

############################################################
############################################################
# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ #
#  fill @tasks ABOVE
# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ #
############################################################
############################################################

MultiTaskGo($ARGV[0], @tasks);
